package ejb;

import javax.persistence.*;

@NamedQuery(
    name="findWork",
    query="SELECT OBJECT(w) from Work w where w.id = :id"
)
@SqlResultSetMapping(name="WorkResults",
    entities=@EntityResult(entityClass=Work.class, fields={
	@FieldResult(name="id", column="WO_NUMBER"),
	@FieldResult(name="status", column="STATUS")
    })
)

@Entity
@Table(name="M_WORKORDER")
public class Work {

    public Work() {}

    public void update() {
	setStatus(getStatus() + 1);
    }

    private Integer id;
    @Id @Column(name="WO_NUMBER")
    public Integer getId() { return id; }
    public void setId(Integer id) { this.id = id; }

    private int status;
    @Column(name="WO_STATUS")
    public int getStatus() { return status; }
    public void setStatus(int s) { status = s; }

    public static Work findWork(EntityManager em, Integer id) {
	Query q = em.createNativeQuery(
		"SELECT w.wo_number AS WO_NUMBER, w.wo_status AS STATUS FROM M_workorder w where w.wo_number = " + id + " FOR UPDATE", "WorkResults");
	return (Work) q.getSingleResult();
    }
}
